#     Copyright (C) 2006 Stewart Adam
#    This file is part of fwfstab.

#    fwfstab is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    fwfstab is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with fwfstab; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import gtk, gtk.glade, gobject, BaseClasses, os

class Callbacks( BaseClasses.Controller ):
	def __init__( self ):
		# Create and ui object contains the widgets.
		ui = BaseClasses.UI('/usr/share/fwfstab/fwfstab.glade' , 'mainwindow', domain=None )
		# init the Controller Class to connect signals.
		BaseClasses.Controller.__init__(self, ui)
	
	### PREP N CHECK ###
	def readfstab(self):
		self.cmd_errout, self.cmd_in = os.popen4("cat /etc/fstab | grep -v '/dev/pts | grep -v '/proc' | grep -v '/sys' | grep -v '/dev/shm''")
		spacesep = []
		self.fstab = []
		# for each line in the fstab, do...
		for i in self.cmd_in.readlines():
			# clear variable, and for each element in [split the fstab by space], do:
			self.fstab = []
			spacesep = []
			if len(i) > 1 and i.find('#') == -1:
				for ii in i.split(' '):
					# if the split has any content, do:
					if len(ii) > 0:
						# (same thing for tabs)
						for iii in ii.split('\t'):
							if len(iii) > 0:
								# Add to temp. variable.
								self.fstab.append(str( str( iii.split('\n')[:1]).split('[\'')[1]).split('\']')[0])
				# add to the list!
				self.addfstabentry(self.fstab)
		# close up.
		self.cmd_errout.close()
		self.cmd_in.close()

	def readmountopts(self):
		# FIXME: Can't have ' (apostrophes) in the file or it glitches.
		file = open('/usr/share/fwfstab/mountoptions', 'r')
		for i in file.readlines():
			self.mountopt = []
			for ii in i.split('\t'):
				self.mountopt.append(str( str( ii.split('\n')[:1]).split('[\'')[1]).split('\']')[0])
			self.addmountoptentry(self.mountopt)
		file.close()

	# Check what filesystems we can (un)mount
	def CheckAvailFS(self):
		self.cmd_errout, self.cmd_in = os.popen4("cat /proc/filesystems | grep -v 'nodev'")
		self.filesystems = []
		for i in self.cmd_in.readlines():
			self.filesystems.append(str(str(str( ''.join(i.split('\t')).split('\n')[:1])).split('[\'')[1]).split('\']')[0])
		self.cmd_errout.close()
		self.cmd_in.close()

	# See if location is editable
	def CheckPerms(self, location):
		if os.access(location, os.R_OK|os.W_OK):
			return True
		else:
			return False

	# Set up list- and tree- views
	def SetupListTreeViews(self):

		# 1 (main page)
		self.ui.cell1s0 = gtk.CellRendererText()
		self.ui.col1s0 = gtk.TreeViewColumn("Device", self.ui.cell1s0, text=0)
		self.ui.treeview1.append_column(self.ui.col1s0)

		self.ui.cell1s1 = gtk.CellRendererText()
		self.ui.col1s1 = gtk.TreeViewColumn("Mount Point", self.ui.cell1s1, text=1)
		self.ui.treeview1.append_column(self.ui.col1s1)

		self.ui.cell1s2 = gtk.CellRendererText()
		self.ui.col1s2 = gtk.TreeViewColumn("Filesystem", self.ui.cell1s2, text=2)
		self.ui.treeview1.append_column(self.ui.col1s2)

		self.ui.cell1s3 = gtk.CellRendererText()
		self.ui.col1s3 = gtk.TreeViewColumn("Mount Options", self.ui.cell1s3, text=3)
		self.ui.treeview1.append_column(self.ui.col1s3)

		self.ui.cell1s4 = gtk.CellRendererText()
		self.ui.col1s4 = gtk.TreeViewColumn("Dump?", self.ui.cell1s4, text=4)
		self.ui.treeview1.append_column(self.ui.col1s4)

		self.ui.cell1s5= gtk.CellRendererText()
		self.ui.col1s5 = gtk.TreeViewColumn("Check on startup?", self.ui.cell1s5, text=5)
		self.ui.treeview1.append_column(self.ui.col1s5)


		# 2 (fstab option help)
		self.ui.cell2s0 = gtk.CellRendererText()
		self.ui.col2s0 = gtk.TreeViewColumn("Option Name", self.ui.cell2s0, text=0)
		self.ui.treeview2.append_column(self.ui.col2s0)

		self.ui.cell2s1 = gtk.CellRendererText()
		self.ui.col2s1 = gtk.TreeViewColumn("Description", self.ui.cell2s1, text=1)
		self.ui.treeview2.append_column(self.ui.col2s1)

		# In general
		self.ui.liststore1 = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING)
		self.ui.treeview1.set_model(self.ui.liststore1)
		self.ui.treeview1.set_reorderable(False)
		self.ui.liststore2 = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING)
		self.ui.treeview2.set_model(self.ui.liststore2)
		self.ui.treeview2.set_reorderable(False)
		self.newmessage(self, 'Finished populating entry tables.')

### WINDOWS ###

	# Show about window
	def on_about1_activate(self, widget):
		self.ui.window2.show()

	# Hide about window
	def about_close(self, widget, event=None):
		self.ui.window2.hide()
		return True

	# Show Detailed Editor (deed) window
	def deed_show(self, widget, event=None):
		if event == None:
			print "DEBUG: Please pass a argument to deed_show()!"
		elif event == 'new':
			# clean out
			self.ui.entry1.set_text('')
			self.ui.entry2.set_text('')
			self.ui.combobox1.set_active(0)
			self.ui.entry3.set_text('')
			self.ui.entry6.set_text('')
			self.ui.checkbutton1.set_active(False)
			self.ui.checkbutton2.set_active(False)
			self.ui.label35.set_text('new')
			self.ui.window3.show()
		elif event == 'edit':
			try:
				( model, iter ) = self.ui.treeview1.get_selection().get_selected()
				val0 = model.get_value(iter, 0)
				val1 = model.get_value(iter, 1)
				val2 = model.get_value(iter, 2)
				val3 = model.get_value(iter, 3)
				val4 = model.get_value(iter, 4)
				val5 = model.get_value(iter, 5)
				self.ui.entry1.set_text(val0)
				self.ui.entry2.set_text(val1)
				self.ui.entry6.set_text(val2)
				self.ui.combobox1.set_active(0)
				self.ui.entry3.set_text(val3)
				if val4 == '0':
					self.ui.checkbutton1.set_active(False)
				else:
					self.ui.checkbutton1.set_active(True)
				if val4 == '0':
					self.ui.checkbutton2.set_active(False)
				else:
					self.ui.checkbutton2.set_active(True)
				self.ui.label35.set_text('edit')
				self.ui.window3.show()
			except TypeError:
				print 'WARNING: Please select a row before clicking Edit!'
				self.newmessage(self, 'Please select a row before clicking Edit!')
				return
		else:
			print 'WARNING: Invalid argument \' ' + event + ' \' passed to deed_show().\nWARNING: Please report a bug and paste this message in the report.'
		self.ui.window3.show()

	# Hide Detailed Editor (deed) window - No saving
	def deed_close_nosave(self, widget, event=None):
		self.ui.window3.hide()
		return True

	# Hide Detailed Editor (deed) window
	def deed_close(self, widget, event=None):
		# Add new row
		if self.ui.label35.get_text() == 'new':
			self.ui.label35.set_text('')
			( model, iter ) = self.ui.treeview1.get_selection().get_selected()
			val0 = self.ui.entry1.get_text()
			add = val0
			val1 = self.ui.entry2.get_text()
			val2 = self.ui.entry6.get_text()
			val3 = self.ui.entry3.get_text()
			if self.ui.checkbutton1.get_active():
				val4 = '1'
			else:
				val4 = '0'
			if self.ui.checkbutton2.get_active():
				val5 = '1'
			else:
				val5 = '0'
			if val0 == None or val0 == '':
				error = 'WARNING: Please fill in all the fields.'
				print error
				self.display_error(error)
				return
			if val1 == None or val1 == '':
				error = 'WARNING: Please fill in all the fields.'
				print error
				self.display_error(error)
				return
			if val2 == None or val2 == '':
				error = 'WARNING: Please fill in all the fields.'
				print error
				self.display_error(error)
				return
			if val3 == None or val3 == '':
				error = 'WARNING: Please fill in all the fields.'
				print error
				self.display_error(error)
				return
			if val4 == None or val4 == '':
				error = 'WARNING: Please fill in all the fields.'
				print error
				self.display_error(error)
				return
			if val5 == None or val5 == '':
				error = 'WARNING: Please fill in all the fields.'
				print error
				self.display_error(error)
				return
			self.addfstabentry([val0,val1,val2,val3,val4,val5])
			self.newmessage(self, 'Added entry' + val0 + '.')
			print 'INFO: Adding ' + add
		# Edit current row (window's modal!)
		if self.ui.label35.get_text() == 'edit':
			self.ui.label35.set_text('')
			( model, iter ) = self.ui.treeview1.get_selection().get_selected()
			edit = self.ui.liststore1.get_value(iter, 0)
			print 'INFO: Editing ' + edit
			val0 = self.ui.entry1.get_text()
			add = val0
			val1 = self.ui.entry2.get_text()
			val2 = self.ui.entry6.get_text()
			val3 = self.ui.entry3.get_text()
			if self.ui.checkbutton1.get_active():
				val4 = '1'
			else:
				val4 = '0'
			if self.ui.checkbutton2.get_active():
				val5 = '1'
			else:
				val5 = '0'
			if val0 == None or val0 == '':
				error = 'WARNING: Please fill in all the fields.'
				print error
				self.display_error(error)
				return
			if val1 == None or val1 == '':
				error = 'WARNING: Please fill in all the fields.'
				print error
				self.display_error(error)
				return
			if val2 == None or val2 == '':
				error = 'WARNING: Please fill in all the fields.'
				print error
				self.display_error(error)
				return
			if val3 == None or val3 == '':
				error = 'WARNING: Please fill in all the fields.'
				print error
				self.display_error(error)
				return
			if val4 == None or val4 == '':
				error = 'WARNING: Please fill in all the fields.'
				print error
				self.display_error(error)
				return
			if val5 == None or val5 == '':
				error = 'WARNING: Please fill in all the fields.'
				print error
				self.display_error(error)
				return
			self.ui.liststore1.set_value(iter, 0, val0)
			self.ui.liststore1.set_value(iter, 1, val1)
			self.ui.liststore1.set_value(iter, 2, val2)
			self.ui.liststore1.set_value(iter, 3, val3)
			self.ui.liststore1.set_value(iter, 4, val4)
			self.ui.liststore1.set_value(iter, 5, val5)
			self.newmessage(self, 'Changes to entry ' + val0 + ' saved.')
		self.ui.window3.hide()
		return True

	# Show error window, set it's text
	def display_error(self, message):
		self.ui.label31.set_text(message)
		self.ui.window4.show()

	# Hide error window
	def on_button9_clicked(self, widget, event=None):
		self.ui.window4.hide()
		return True

### POPULATORS ###

	# Populates 1 line of the listview with a fstab entry
	def addfstabentry(self, entry):
		try:
			self.ui.liststore1.append(entry)
		except ValueError:
			print 'ERROR: Error parsing fstab at line ' + entry

	# Populates 1 line of the listview with a mount option entry
	def addmountoptentry(self, entry):
		self.ui.liststore2.append(entry)

	# Populates the fstab with lines. (writes to it)
	def writerow(self, model, path, iter, user_data):
		# get value from current row, column 1
		val0 = model.get_value(iter, 0)
		val1 = model.get_value(iter, 1)
		val2 = model.get_value(iter, 2)
		val3 = model.get_value(iter, 3)
		val4 = model.get_value(iter, 4)
		val5 = model.get_value(iter, 5)
		fstab=open(user_data, 'a')
		fstab.write(val0 + '\t' + val1 + '\t' + val2 + '\t' + val3 + '\t' + val4 + ' ' + val5 + '\n')
		fstab.close()


### EVENT CALLBACKS ###

	# Close
	def close(self, widget=None, event=None):
		gtk.main_quit()
		return False

	# Save
	def save(self, widget=None, event=None):
		user_data = "/etc/fstab"
		file = open(user_data,'a')
		file.write('')
		file.close()
		if self.CheckPerms(user_data):
			os.rename(user_data, user_data + '.backup')
			self.ui.liststore1.foreach(self.writerow, user_data)
		else:
			error = 'Error: You don\'t have permissions to /etc/fstab! Changes will not be saved.'
			print error
			self.display_error(error)
			return
		return True

	# Just save
	def on_save1_activate(self, widget):
		print 'INFO: Saving'
		self.save()
		self.newmessage(self, 'Your changes are now saved. A backup of your previous fstab was created.')

	# Quit, no save
	def on_quit1_activate(self, widget):
		print 'INFO: Quiting without saving.'
		self.close()

	# Quit, but save
	def on_button8_clicked(self, widget):
		print 'INFO: Saving and quitting.'
		self.save()
		self.close()

	# Add
	def on_button2_clicked(self, widget):
		self.deed_show(self, 'new')

	# Edit
	def on_button4_clicked(self, widget):
		self.deed_show(self, 'edit')

	def on_button7_clicked(self, widget):
		self.deed_close(self)

	def on_button13_clicked(self, widget):
		self.deed_close_nosave(self)

	# Remove
	def on_button3_clicked(self, widget):
		( model, iterator ) = self.ui.treeview1.get_selection().get_selected()
		try:
			drive = self.ui.liststore1.get_value(iterator, 0)
			path = self.ui.liststore1.get_value(iterator, 1)
			self.newmessage(self, 'Removed entry ' + drive + '.')
			print 'INFO: Removed ' + drive + ', previously mounted under ' + path
			self.ui.liststore1.remove(iterator)
		except TypeError:
			print 'WARNING: Please select a row before clicking Remove!'
			self.newmessage(self, 'Please select a row before clicking Remove!')

	# Mount drive
	def on_button5_clicked(self, widget):
		( model, iterator ) = self.ui.treeview1.get_selection().get_selected()
		try:
			drive = self.ui.liststore1.get_value(iterator, 0)
			path = self.ui.liststore1.get_value(iterator, 1)
			print 'INFO: Mounted ' + drive + ' with mountpoint ' + path
			self.newmessage(self, 'Mounted ' + drive + ' with mountpoint ' + path)
		except TypeError:
			print 'WARNING: Please select a row before clicking Mount!'
			self.newmessage(self, 'Please select a row before clicking Mount!')
			return
		self.cmd_errout, self.cmd_in = os.popen4("mount " + path)
		text = []
		for i in self.cmd_in.readlines():
				# if the split has any content, do:
			if len(i) > 0:
				text.append(i)
		error = '\n'.join(text)
		if error != '':
			self.display_error(error)
			print [error]
		self.cmd_errout.close()
		self.cmd_in.close()

	# Unnount drive
	def on_button6_clicked(self, widget):
		( model, iterator ) = self.ui.treeview1.get_selection().get_selected()
		try:
			drive = self.ui.liststore1.get_value(iterator, 0)
			path = self.ui.liststore1.get_value(iterator, 1)
			print 'INFO: Unmounted ' + drive + ' with mountpoint ' + path
			self.newmessage(self, 'Unmounted ' + drive + ' with mountpoint ' + path)
		except TypeError:
			print 'WARNING: Please select a row before clicking Unmount!'
			self.newmessage(self, 'Please select a row before clicking Unmount!')
			return
		self.cmd_errout, self.cmd_in = os.popen4("umount " + path)
		text = []
		for i in self.cmd_in.readlines():
				# if the split has any content, do:
			if len(i) > 0:
				text.append(i)
		error = '\n'.join(text)
		if error != '':
			self.display_error(error)
			print [error]
		self.cmd_errout.close()
		self.cmd_in.close()

	def on_help1_activate(self, widget):
		self.ui.notebook3.set_current_page(1)

	def newmessage(self, widget, message):
		try:
			self.message_timeout(self)
		except AttributeError:
			pass
		self.ui.statusbar1.push(1, message)
		self.message_timer = gobject.timeout_add(3000, self.message_timeout)

	# remove any timer
	def stop(self, widget, timer):
		gobject.source_remove(timer)

		# TIMEOUTS

	def message_timeout(self, widget=None):
		self.ui.statusbar1.pop(1)
		self.stop(self, self.message_timer)
		return True
